/**
* @file mc_control.c
*
* Copyright (c) 2004 Atmel.
*
* @brief ̕AT90PWM3p̑x̻޽񋟂܂B
* `: PID͔AϕAӖ܂B
*
* @version 1.0 (CVS revision : 1.3)
* @date 2006/02/13 12:32:54
* @author raubree
*****************************************************************************/
#include "config.h"
#include "inavr.h"

/* xϐ */
S16 speed_error=0;				//!< 덷vZ
S16 speed_integral = 0;
S16 speed_integ = 0;
S16 speed_proportional = 0;

/**************************************************************************************/
/*					x														  */
/**************************************************************************************/
/**
* @brief	x䕔
* @return	x(16ޯĂޭè )
*			speed_measure10ޯĂ̕\܂B
*/
S16 mc_control_speed_16b(S16 speed_ref , S16 speed_measure)
{
  S16 Duty = 0;
  S16 increment = 0;

  // 덷vZ
  speed_error = speed_ref - speed_measure ;

  // ፀvZ: Kp=7/64=0.1
  speed_proportional = ( speed_error/8 - speed_error/64 );

  // ϕvZ
  speed_integral = speed_integral + speed_error;

  // xϕOa
  if(speed_integral >  32000) speed_integral =  32000;
  if(speed_integral < -32000) speed_integral = -32000;

  // speed_integ=Ki_speed*speed_integralAKi_speed=29/8192=3e-3
  speed_integ = (speed_integral - speed_integral/8 + speed_integral/32) / 256 ;

  // ޭè ٌvZ
  increment = speed_proportional + speed_integ;
  increment = (increment/2 + increment/4) ;			// Ώo͐K

  // Ώo̖͂Oa
  if( increment > (S16)(0) ) {
    if  (increment <= (S16)(192)) Duty = (S16)increment ;
     else Duty = 192 ;
  }
  else {
    if  (increment < (S16)(-192)) Duty = -192 ;
     else Duty = (S16)increment ;
  }

  // ޭè قԂ
  return Duty;
}
