//**************************************************************************
//! @file eusart_lib.c,v
//!
//! Copyright (c) 2005 Atmel.
//!
//! ۸тATMEL̍ŏIgpҋ_KvƂ܂B
//! 쌠ʒmɂĂlicense.txţقǂłB
//!
//! @brief ̧قATMEL̑SĂPWM޲pEUSARTײ ٰ݂܂݂܂B
//!
//! ̐`̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! Ȃ۸т̿ĳ\̧̂ق̋@\IȋLqɒuĂB
//!
//! @version 1.11 pwm3-ac-ctrl-motor-0_0_6
//!
//! @todo
//! @bug
//**************************************************************************

//_____ ݸٰ _______________________________________________________________

#include "config.h"
#include "lib_mcu\eusart\eusart_lib.h"
#include "lib_mcu\eusart\eusart_drv.h"

//_____ S̒` ______________________________________________________________

//					| ޯ7: ޯ17
//					| ޯ6: F1617
//					| ޯ5:  ڰݸތ
// eusart_rx_error <  ޯ4: ڰݸތ
//					| ޯ3: ް ްُ݈
//					| ޯ2: è
//					| ޯ1: ~ޯ1
//					| ޯ0: ~ޯ0
U8 eusart_rx_error;

//_____ ` __________________________________________________________________

//_____ ϸ ___________________________________________________________________

//_____ ֐ __________________________________________________________________

//--------------------------------------------------------------------------
//  @fn eusart_init
//!
//! EUSART(&USART)Ӌ@\BEUSARTUART̗ؾĂĂ̎Ӌ@\
//! Aċ܂B
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		
//!				==TRUE:		֐͎s܂B
//!				==FALSE:	֐͎s܂B
//!
//--------------------------------------------------------------------------
Bool eusart_init (U8 nbbit_tx, U8 nbbit_rx, t_encoding mode, \
				  t_bit_order order, U16 fosc, U16 bdr, t_parity_type parity, \
				  U8 stop_tx, U8 stop_rx)
{
  Eusart_clear();											//- EUSART
  eusart_rx_error = 0x00 ;									//- SĂ̑S׸މ
  Eusart_enable();											//- EUSART`Ԑݒ
  //- `
  if (mode==MANCHESTER) { Eusart_enable_manchester();  }
  else                  { Eusart_disable_manchester(); }
  //- ް ޯď
  if (order==MSB_FIRST) { Eusart_enable_msb_first(); }
  else                  { Eusart_enable_lsb_first(); }
  //- ]x`Ԑݒ
  Eusart_set_mubrr(fosc, bdr);								// v
  Eusart_set_ubrr(fosc,  bdr);								// ްڰĔ
  //- ް ޯĒ
  Eusart_set_size(nbbit_tx, nbbit_rx);
  //- è
  if (mode!=MANCHESTER) { Uart_set_parity(parity); }
  //- M~ޯ
  if (stop_tx==1) { Uart_set_one_tx_stop(); }
  else            { Uart_set_two_tx_stop(); }
  //- M~ޯ
  if (stop_rx==1) { Eusart_set_one_rx_stop(); }
  else            { Eusart_set_two_rx_stop(); }
  //- M
  Eusart_enable_rx();
  Eusart_enable_tx();
  return TRUE;
}

//--------------------------------------------------------------------------
//  @fn eusart_clear
//!
//! EUSART(&USART)Ӌ@\֎~BEUSARTUART̗֎~ASڼ޽
//! (ؾ)l܂B
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		Ȃ
//!
//--------------------------------------------------------------------------
void eusart_clear(void)
{
  Eusart_clear();
}

//--------------------------------------------------------------------------
//  @fn eusart_disable
//!
//! EUSART(&USART)Ӌ@\֎~BEUSARTUART̗֎~AMɏՕ
//! ܂B
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		Ȃ
//!
//--------------------------------------------------------------------------
void eusart_disable(void)
{
  U16 dummy;

  Eusart_disable_tx();
  while(Eusart_rx_ready())		// MɏՕ󂯂B
  {
	dummy=eusart_get();
	dummy=~dummy;				// ׂ߲ɂĎ󂯓ׂ
  }
  Eusart_ack_tx();

  //- M֎~
  Eusart_disable_rx();
  Eusart_disable_tx();

  //- EUSART()`Ԑݒ
  Eusart_disable();
}

//--------------------------------------------------------------------------
//  @fn eusart_enable
//!
//! EUSART(&USART)Ӌ@\BEUSARTUART܂B
//!
//! @warning	ȑO'eusart_init()'sȂ΂Ȃ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
//--------------------------------------------------------------------------
void eusart_enable(void)
{
  eusart_rx_error = 0x00 ;
  Eusart_ack_tx();

  //- EUSART`Ԑݒ
  Eusart_enable();

  //- M
  Eusart_enable_rx();
  Eusart_enable_tx();
}

//--------------------------------------------------------------------------
//  @fn eusart_tx_done
//!
//! ްEUSARTӋ@\ɂđꂽǗ
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		Status
//!				==TRUE:		Ms܂B
//!				==FALSE:	Mis
//!
//--------------------------------------------------------------------------
Bool eusart_tx_done(void)
{
  if (Eusart_tx_complete()!=0)
  {
	Eusart_ack_tx();
	return TRUE;
  }
  else return FALSE;
}

//--------------------------------------------------------------------------
//  @fn eusart_put
//!
//! EUSARTӋ@\ް𑗐M
//!
//! @warning	Ȃ
//!
//! @param		EUSARToRőoް
//!
//! @return		ް
//!
//--------------------------------------------------------------------------
U16 eusart_put(U16 ch)
{
  Union16 c;

  c.w = ch;
#ifndef EUSART_USED_FOR_DALI
  while(!Eusart_tx_buffer_ready());
#endif
  Eusart_put_msb(MSB(c));		// Ⴆ8ޯĈȉްł
  Eusart_put_lsb(LSB(c));
  return ch;
}

//--------------------------------------------------------------------------
//  @fn eusart_rx_ready
//!
//! ްEUSARTӋ@\ŏǗ
//!
//! @warning	Ȃ
//!
//! @param		Ȃ
//!
//! @return		Status
//!				==TRUE:		ް
//!				==FALSE:	ްȂ
//!
//--------------------------------------------------------------------------
Bool eusart_rx_ready(void)
{
  if (Eusart_rx_ready()!=0) return TRUE;
  else return FALSE;
}

//--------------------------------------------------------------------------
//  @fn eusart_get
//!
//! EUSARTӋ@\ް擾A"eusart_rx_error"S̕ϐXV
//!
//! @warning	"eusart_rx_error"ޯč\(ͯގQ)
//!				"return"޲č\
//!
//! @param		Ȃ
//!
//! @return		EUSARTł(Mꂽ)ǂݎް
//!
//--------------------------------------------------------------------------
U16 eusart_get(void)
{
  U16 eusart_data;
  //- RxCҋ@
#ifndef EUSART_USED_FOR_DALI
  while(!Eusart_rx_ready());
#endif
  //- ~ޯēǂݍ
  eusart_rx_error = Eusart_get_stp();
  //- Sُ׸ޕߊl
  eusart_rx_error |= Eusart_get_parity_error();		// è
  eusart_rx_error |= Eusart_get_ovr_error();		// ް ُ݈
  eusart_rx_error |= Eusart_get_fe_error();			//  ڰݸތ
  eusart_rx_error |= Eusart_get_fem_error();		//  ڰݸތ
  //- F16肻̌ޯ17ǂݍ
  eusart_rx_error |= Eusart_get_f1617();
  eusart_rx_error |= Eusart_get_bit17();

  //- ްɏՕǂݍ
  eusart_data  = (U16)(Eusart_get_msb() << 8);
  eusart_data |= (U16)(Eusart_get_lsb());

  return eusart_data;
}
